import type { JSXOutput, QRL } from "@builder.io/qwik";
import { THeadClassNames, TBodyClassNames, TableClassNames } from "./class.types";
import { SortConfig, SortOptions } from "./sort.types";
import { FilterConfig, FilterOptions, FilterTypes, FilterValue } from "./filter.types";
export type THeadProps = {
    headings: Array<string>;
    customHeadings: undefined | {
        [heading: string]: string;
    };
    classNames: THeadClassNames;
    sortOptions: SortOptions | undefined;
    sortConfig: SortConfig;
    filterOptions: FilterOptions | undefined;
    filterConfig: FilterConfig;
};
export type SortArrows = {
    heading: string;
    classNames: THeadClassNames;
    sortConfig: SortConfig;
};
export type FilterInput = {
    heading: string;
    classNames: THeadClassNames;
    filterType: FilterTypes;
    filterConfig: FilterConfig;
    options?: Array<FilterValue>;
};
export type CellData = {
    [key: string]: JSXOutput;
};
export type TBodyProps = {
    data: Array<CellData>;
    headings: Array<string>;
    classNames: TBodyClassNames;
    element?: {
        [key: string]: QRL<(record: CellData, param: string) => JSXOutput>;
    };
};
export type TableData = {
    tData: Array<CellData>;
    element?: {
        [key: string]: QRL<(record: CellData, param: string) => JSXOutput>;
    };
    tableOptions?: {
        customHeadings?: {
            [heading: string]: string;
        };
        classNames?: TableClassNames;
        sortOptions?: SortOptions;
        filterOptions?: FilterOptions;
    };
};
export type TableConfigs = {
    data: Array<CellData>;
    sortConfig: SortConfig;
    filterConfig: FilterConfig;
};
